using System;
using Server;
using System.Collections;

namespace Server.Spells.FSB
{
    public class FSBSchoolList
    {
        public static ArrayList SchoolList;

        public static void Initialize()
        {
            SchoolList = new ArrayList();

            SchoolList.Add( new FSBSchoolInfo( "None", "", SchoolFlag.None, false, false, 0 ) );
            SchoolList.Add( new FSBSchoolInfo( "Options", "", SchoolFlag.None, false, false, 0 ) );

/*******************\Instructions/*******************/
/* To add a new school, place the name in the first */
/* brackets, and the range of numbers in the second */
/* The order in the list depicts the order in-game. */
/* I believe I've been able to catch all errors, so */
/* if you happen to mess up, it should tell you on  */
/* the console (Server window) which spell is wrong */
/*  If you add new schools, and wish to be able to  */
/*  turn them on/off for your books in-game, you    */
/*  need to go into TomeOfKnowledge.cs and follow   */
/*  the instructions provided.                      */
/*              See also ReadMeFirst.cs             */
/*******************\Instructions/*******************/
//Def		SchoolList.Add( new FSBSchoolInfo( "NAME", "RANGES", School, RequiresScrolls, StaffOnly, IconBackgroundID ) );

			SchoolList.Add( new FSBSchoolInfo( "Magery",     "00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63", SchoolFlag.Magery, true, false, 9350 ) );
			SchoolList.Add( new FSBSchoolInfo( "Necro",      "100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115", SchoolFlag.Necro, true, false, 3600 ) );
			SchoolList.Add( new FSBSchoolInfo( "Chivalry",   "200 201 202 203 204 205 206 207 208 209 210 211 212", SchoolFlag.Chivalry, false, false, 9300 ) );
//			SchoolList.Add( new FSBSchoolInfo( "Ninja",      "400 401 402 403 404 405", SchoolFlag.Ninja, false, false, 83 ) );
//			SchoolList.Add( new FSBSchoolInfo( "Samurai",    "500 501 502 503 504 505 506 507", SchoolFlag.Samurai, false, false, 2620 ) );
			SchoolList.Add( new FSBSchoolInfo( "Undead",     "116 117 118 119 120 121 122 123 124 125 126 127 128", SchoolFlag.Undead, true, false, 9270 ) );
			SchoolList.Add( new FSBSchoolInfo( "Rogue",      "150 151 152 153 154", SchoolFlag.Rogue, true, false, 5100 ) );
			SchoolList.Add( new FSBSchoolInfo( "Ancient",    "340 341 342 343 344 345 346 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 368 369 370 372 373 374 380 382", SchoolFlag.Ancient, true, true, 5170 ) );
			SchoolList.Add( new FSBSchoolInfo( "Druid",      "551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566", SchoolFlag.Druid, true, false, 5120 ) );
			SchoolList.Add( new FSBSchoolInfo( "Cleric",     "601 602 603 604 605 606 607 608 609 610 611 612", SchoolFlag.Cleric, true, false, 3500 ) );
			SchoolList.Add( new FSBSchoolInfo( "Bard",       "651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666", SchoolFlag.Bard, true, false, 3000 ) );
			SchoolList.Add( new FSBSchoolInfo( "Ranger",     "900 901 902 903 904 905 906 907", SchoolFlag.Ranger, true, false, 5054 ) );

//Template
//			SchoolList.Add( new FSBSchoolInfo( "", "", SchoolFlag.None, false, false, 0 ) );
        }

        public static int FindBackgroundInfo( SchoolFlag flag )
        {
            for( int i = 0; i < SchoolList.Count; i++ )
            {
				FSBSchoolInfo si = SchoolList[i] as FSBSchoolInfo;
                if( si != null )
                    if( si.School == flag )
                    	return si.Background;
            }
            return -1;
        }

        public static int GetIndex( FSBSchoolInfo info )
        {
            for( int i = 0; i < SchoolList.Count; i++ )
            {
                if( info == (FSBSchoolInfo)SchoolList[i] )
                    return i;
            }
            return -1;
        }
    }
}