/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~      Version [5].0.1        _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using Server;
using Server.Items;


//--DestroyingAngel Reagent----------------------------------------------------------------
namespace Server.Items
{
   public class DestroyingAngel : BaseReagent, ICommodity
   {
      string ICommodity.Description
      {
         get
         {
            return String.Format( "{0} destroying angel", Amount );
         }
      }

      [Constructable]
      public DestroyingAngel() : this( 1 )
      {
      }

      [Constructable]
      public DestroyingAngel( int amount ) : base( 0xE1F, amount )
      {
         Hue = 0x290;
         Name = "destroying angel";
      }

      public DestroyingAngel( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 1 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
         
      	if (version==0)
      		this.ItemID=3971;
      }
   }
}


//--PetrifiedWood Reagent------------------------------------------------------------------
namespace Server.Items
{
   public class PetrifiedWood : BaseReagent, ICommodity
   {
      string ICommodity.Description
      {
         get
         {
            return String.Format( "{0} petrified wood", Amount );
         }
      }

      [Constructable]
      public PetrifiedWood() : this( 1 )
      {
      }

      [Constructable]
      public PetrifiedWood( int amount ) : base( 0x97A, amount )
      {
         Hue = 0x46C;
         Name = "Petrified Wood";
      }

      public PetrifiedWood( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 1 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
         
      		if (version==0)
      		this.ItemID=3984;
      }
   }
}


//--SpringWater Reagent-------------------------------------------------------------------
namespace Server.Items
{
   public class SpringWater : BaseReagent, ICommodity
   {
      string ICommodity.Description
      {
         get
         {
            return String.Format( "{0} spring water", Amount );
         }
      }

      [Constructable]
      public SpringWater() : this( 1 )
      {
      }

      [Constructable]
      public SpringWater( int amount ) : base( 0xE24, amount )
      {
         Hue = 0x47F;
         Name = "spring water";
      }

      public SpringWater( Serial serial ) : base( serial )
      {
      }

      public override void Serialize( GenericWriter writer )
      {
         base.Serialize( writer );
         writer.Write( (int) 0 ); // version
      }

      public override void Deserialize( GenericReader reader )
      {
         base.Deserialize( reader );
         int version = reader.ReadInt();
      }
   }
}
