using System;
using Server;
using Server.Items;
using Server.Spells.Linear;


namespace Server.Items
{
	public class AwakenScroll : SpellScroll
	{
		[Constructable]
		public AwakenScroll() : this( 1 )
		{
		}

		[Constructable]
		public AwakenScroll( int amount ) : base( 853, 0x1F32, amount )
		{
			Name = "Awaken Scroll";
			Hue = 1355;
		}

		public AwakenScroll( Serial serial ) : base( serial )
		{
		}

      	public override void OnDoubleClick( Mobile from )
      	{
			if ( from.AccessLevel <= AccessLevel.Counselor )
			{
				//--<Optional Restrictions>----------<Start>
				from.SendMessage( "Low level staff and players are not allowed to have this scroll." );
				Delete();
			}
			else
			{
               		new AwakenSpell( from, null).Cast();
				Delete();
			}
     		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}
