using System;
using Server;
using Server.Items;
using Server.Spells.Eighth;


namespace Server.Items
{
	public class InvisibilityAllScroll : SpellScroll
	{
		[Constructable]
		public InvisibilityAllScroll() : this( 1 )
		{
		}
		
		[Constructable]
		public InvisibilityAllScroll( int amount ) : base( 882, 0x1F65, amount )
		{
			Name = "Invisibility All Scroll";
			Hue = 1355;
		}
		
		public InvisibilityAllScroll( Serial serial ) : base( serial )
		{
		}
		
		public override void OnDoubleClick( Mobile from )
		{
			if ( from.AccessLevel <= AccessLevel.Counselor )
			{
				//--<Optional Restrictions>----------<Start>
				from.SendMessage( "Low level staff and players are not allowed to have this scroll." );
				Delete();
			}
			else
			{
               		new InvisibilityAllSpell( from, null).Cast();
				Delete();
			}
		}
		
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}
