using System;
using System.Text;
using Server;
using Server.Gumps;
using Server.Items;
using Server.Network;
using Server.Mobiles;
using Server.Spells.First;
using Server.Spells;
using Server.Misc;

namespace Server.Spells.FSB
{
	public class SpellIconGump : Gump
	{
		int m_Icon;
		int m_Spell;
		int m_Background;
		TomeOfKnowledge m_Book;

		public SpellIconGump( TomeOfKnowledge book, Mobile from, int x, int y, int icon, int spellID, int background )
			: base( x, y )
		{
			m_Book = book;
			m_Icon = icon;
			m_Spell = spellID;
			m_Background = background;

			Closable=false;
			Disposable=false;
			Dragable=false;
			Resizable=false;
			AddPage(0);
			AddBackground( 0, 0, 54, 54, background );
			AddButton( 45, 0, 9008, 9010, (int)Buttons.Close, GumpButtonType.Reply, 0 );
			AddButton( 5, 5, icon, icon, (int)Buttons.Cast, GumpButtonType.Reply, 0 );
		}

		public enum Buttons
		{
			Exit,
			Cast,
			Close,
		}

		public override void OnResponse( NetState state, RelayInfo info )
		{
			if( m_Book.Deleted )
				return;

			Mobile from = state.Mobile;
			switch( info.ButtonID )
			{
				case (int)Buttons.Close:
				{
					int remove = 0;
					bool doremove = false;

					int count = m_Book.DragableIcons.Count;
					for( int i = 0; i < count; i++ )
					{
						IconInfo ii = (IconInfo)m_Book.DragableIcons[i];
						if( ii.Icon == m_Icon )
						{
							doremove = true;
							remove = i;
						}
					}
					if( doremove )
					{
						m_Book.DragableIcons.RemoveAt( remove );
						from.SendMessage("That icon has been removed and will not open again");
					}
					break;
				}

				case (int)Buttons.Cast:
				{
					if( m_Spell != 999 )
					{
						int x = this.X;
						int y = this.Y;
						Spell spell = SpellRegistry.NewSpell( m_Spell, from, null );
						spell.Cast();
						from.SendGump( new SpellIconGump( m_Book, from, x, y, m_Icon, m_Spell, m_Background ) );
					}
					else
					{
						from.SendMessage("This spell has been disabled");
					}
					break;
				}
			}
		}
	}
}