using System;
using Server;
using System.Collections;

namespace Server.Spells.FSB
{
    public class FSBSpellList
    {
        public static ArrayList SpellList;

        public static void Initialize()
        {
			if( SpellList == null )
            	SpellList = new ArrayList();
            /****** Instructions ******\
            SpellList.Add( new FSBSpellInfo( "Name", "Info", ID, Icon, Mana, Skill, "Reagents", SchoolFlag.School ) );
            Name = String name of Spell
            Info = String description
            ID = Int Initializer.sc ID of spell
            Icon = Int Icon GumpID of spell Icon
            Mana = Int Mana required
            Skill = Double Skill required
            Reagents = String of abreviations of Reagents required, seperated by commas(From following list) (5 max)

            BP = Black Pearn
            BM = Bloodmoss
            GA = Garlic
            GI = Ginseng
            MR = Mandrake Root
            NS = Nightshade
            SA = Sulfurous Ash
            SS = Spider's Silk
            BW = Bat Wing
            GD = Grave Dust
            DB = Daemon Blood
            NC = Nox Crystal
            PI = Pig Iron
            PW = Petrafied Wood
            SW = Spring Water
            DA = Destroying Angel
            T.# = Tithe
             ^ is a period
            */
/********************\ATTENTION/***********************/
/*   If you add new Abreviations here, you must add   */
/*  the conversions at the end of this file as well.  */
/********************\ATTENTION/***********************/
            #region SpellList
            //Mage First Circle
            SpellList.Add( new FSBSpellInfo( "Clumsy", "Temporarily reduces Target's Dexterity.", 00, 2240, 4, .1, "BM,NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Create Food", "Creates random food item in Caster's backpack.", 01, 2241, 4, .1, "GA,GI,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Feeblemind", "Temporarily reduces Target's Intelligence.", 02, 2242, 4, .1, "NS,GI", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Heal", "Heals Target of a small amount of lost Hit Points.", 03, 2243, 4, .1, "GA,GI,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Magic Arrow", "Shoots a magical arrow at Target, wich deals Fire damage.", 04, 2244, 4, .1, "SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Night Sight", "Temporarily allows Target to see in darkness.", 05, 2245, 4, .1, "SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Reactive Armor", "Increases the Caster's Physical Resistance while reducing their Elemental Resistances.  The Caster's Inscription skill adds a bonus to the amount of Physical Resist applied.  Active until spell is deactivated by re-casting the spell on the same Target.", 06, 2246, 4, .1, "GA,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Weaken", "Temporarily reduces Target's Strength.", 07, 2247, 4, .1, "GA,NS", SchoolFlag.Magery ) );

            //Mage Second Circle
            SpellList.Add( new FSBSpellInfo( "Agility", "Temporarily increases Target's Dexterity.", 08, 2248, 6, .1, "BM,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Cunning", "Temporarily increases Target's Intelligence.", 09, 2249, 6, .1, "NS,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Cure", "Attempts to neutralize poisons affecting the Target.", 10, 2250, 6, .1, "GA,GI", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Harm", "Affects the Target with a chilling effect, dealing Cold damage.  The closer the Target is to the Caster, the more damage is dealt.", 11, 2251, 6, .1, "NS,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Magic Trap", "Places an explosive magic ward on a useable object that deals Fire damage to the next person to use the object.", 12, 2252, 6, .1, "GA,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Magic Untrap", "Deactivates a magical trap on a single object.", 13, 2253, 6, .1, "BM,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Protection", "Prevents the Target from having their spells disrupted, but lowers their Physical Resistances and ability to Resist Spells.  Active until the spell is deactivated by recasting on the same Target.", 14, 2254, 6, .1, "GA,GI,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Strength", "Temporarily increases Target's Strength.", 15, 2255, 6, .1, "MR,NS", SchoolFlag.Magery ) );

            //Mage Third Circle
            SpellList.Add( new FSBSpellInfo( "Bless", "Temporarily increases Target's Strength, Dexterity, and Intelligence.", 16, 2256, 9, 10.1, "MR,GA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Fireball", "Shoots a ball of roiling flames at a Target, dealing Fire damage.", 17, 2257, 9, 10.1, "BP", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Magic Lock", "Magically seals a container, blocking it from use until it is Magically Unlocked.", 18, 2258, 9, 10.1, "BM,GA,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Poison", "The Target is afflicted by poison, of a strength determined by the Caster's Magery and Poison skills, and the distance from the Target.", 19, 2259, 9, 10.1, "NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Telekinesis", "Allows the Caster to Use an item at a distance.", 20, 2260, 9, 10.1, "BM,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Teleport", "Caster is transported to the Target Location.", 21, 2261, 9, 10.1, "BM,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Unlock", "Unlocks a magical lock or low level normal lock.", 22, 2262, 9, 10.1, "BM,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Wall of Stone", "Creates a temporary wall of stone that blocks movement.", 23, 2263, 9, 10.1, "BM,GA", SchoolFlag.Magery ) );

            //Mage Fourth Circle
            SpellList.Add( new FSBSpellInfo( "Arch Cure", "Neutralizes poisons on all characters withing a small radius around the caster.", 24, 2264, 11, 24.1, "GA,GI,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Arch Protection", "Applies the Protection spell to all valid targets within a small radius around the Target Location.", 25, 2265, 11, 24.1, "GA,GI,MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Curse", "Lowers the Strength, Dexterity, and Intelligence of the Target.  When cast during Player vs. Player combat, the spell also reduces the target's maximum resistance values.", 26, 2266, 11, 24.1, "GA,NS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Fire Field", "Summons a wall of fire that deals Fire damage to all who walk through it.", 27, 2267, 11, 24.1, "BP,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Greater Heal", "Heals the target of a medium amount of lost Hit Points.", 28, 2268, 11, 24.1, "GA,GI,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Lightning", "Strikes the Target with a bolt of lightning, wich deals Energy damage.", 29, 2269, 11, 24.1, "MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Mana Drain", "Temporarily removes an amount of mana from the Target, based on a comparison between the Caster's Evaluate Intelligence sill and the Target's Resist Spells skill.", 30, 2270, 11, 24.1, "BP,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Recall", "Caster is transported to the location marked on the Target rune.  If a ship key is target, Caster is transported to the boat the key opens.", 31, 2271, 11, 24.1, "BP,BM,MR", SchoolFlag.Magery ) );

            //Mage Fifth Circle
            SpellList.Add( new FSBSpellInfo( "Blade Spirits", "Summons a whirling pillar of blades that selects a Target to attack based off of its combat strength and proximity.  The Blade Spirit disappears after a set amount of time.  Requires 1 pet control slot.", 32, 2272, 14, 38.1, "BP,MR,NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Dispel Field", "Destroys one of the target Field spell.", 33, 2273, 14, 38.1, "BP,GA,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Incognito", "Disuises the Caster with a randomly generated appearance and name.", 34, 2274, 14, 38.1, "BM,GA,NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Magic Reflection", "Lowers the caster's Physical resistances, while increasing their Elemental resistances.  Active until the spell is deactivated by recasting on the same Target.", 35, 2275, 14, 38.1, "GA,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Mind Blast", "Deals Cold damage to the Target based off Caster's Magery and Intelligence.", 36, 2276, 14, 38.1, "BP,MR,NS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Paralyze", "Immobilizes the Target for a brief amount of time.  The Target's Resisting Spells skill affects the Duration of the immobilization.", 37, 2277, 14, 38.1, "GA,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Poison Field", "Conjures a wall of poisonous vapor that poisons anything that walks through it.", 38, 2278, 14, 38.1, "BP,NS,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Summon Creature", "Summons a random creature as a pet for a limited duration.  The strength of the summoned creature is based off of the Caster's Magery skill.", 39, 2279, 14, 38.1, "BM,MR,SS", SchoolFlag.Magery ) );

            //Mage Sixth Circle
            SpellList.Add( new FSBSpellInfo( "Dispel", "Attempts to Dispel a summoned creature, causing it to disapear from the world.  The Dispel difficulty is affected by the Magery skill of the creature's owner.", 40, 2280, 20, 52.1, "GA,MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Energy Bolt", "Fires a bold of magical force at the Target dealing Energy damage.", 41, 2281, 20, 52.1, "BP,NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Explosion", "Strikes the Target with an explosive blast of energy, dealing Fire damage.", 42, 2282, 20, 52.1, "BM,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Invisibility", "Temporarily causes the Target to become invisible.", 43, 2283, 20, 52.1, "BM,NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Mark", "Binds a rune to the Caster's current Location.  The Mage's Recall spell and Paladin's Sacred Journey ability can both be used on the rune to teleport the Caster to the location of binding.", 44, 2284, 20, 52.1, "BP,BM,MR", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Mass Curse", "Casts the Curse spell on a Target, and any creatures within a two tile radius.", 45, 2285, 20, 52.1, "GA,MR,NS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Paralyze Field", "Conjures a field of paralyzing energy that affects any creature that enters it with the effects of the Paralyze spell.", 46, 2286, 20, 52.1, "BP,GI,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Reveal", "Reveals the presence of any invisible or hiding creatures or players within a radius around the targeted tile.", 47, 2287, 20, 52.1, "BM,SA", SchoolFlag.Magery ) );

            //Mage Seventh Circle
            SpellList.Add( new FSBSpellInfo( "Chain Lightning", "Damages nearby targets with a series of lightning bolts that deal Energy damage.", 48, 2288, 40, 66.1, "BP,BM,MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Energy Field", "Conjures a temporary field of energy on the ground at the Target Location that blocks all movement.", 49, 2289, 40, 66.1, "BP,MR,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Flame Strike", "Envelopes the target in a column of magical flame that deals Fire damage.", 50, 2290, 40, 66.1, "SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Gate Travel", "Targeting a rune marked with the Mark spell, opens a temporary portal to the rune's marked location.  The portal can be used by anyone to travel to that location.", 51, 2291, 40, 66.1, "BP,MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Mana Vampire", "Drains mana from the Target and transfers it to the Caster.  The amount of mana drained is determined by a comparison between the Caster's Evaluate Intelligence skill and the Target's Resisting Spells skill.", 52, 2292, 40, 66.1, "BP,BM,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Mass Dispel", "Attempts to dispel any summoned creature within an eight tile radius.", 53, 2293, 40, 66.1, "BP,GA,MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Meteor Swarm", "Summons a swarm of fiery meteors that strike all targets within a radius around the Target Location.  The total Fire damage dealt is split between all Targets of the spell.", 54, 2294, 40, 66.1, "BM,MR,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Polymorph", "Temporarily transforms the Caster into a creature selected from a specified list.  While polymorphed, other players will see the Caster as a criminal.", 55, 2295, 40, 66.1, "BM,MR,SS", SchoolFlag.Magery ) );

            //Mage Eigth Circle
            SpellList.Add( new FSBSpellInfo( "Earthquake", "Causes a violent shaking of the earth that damages all nearby creatures and characters.", 56, 2296, 50, 80.1, "BM,GI,MR,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Energy Vortex", "Summons a spinning mass of energy that selects a Target to attack based off of its intelligence and proximity.  The Energy Vortex disappears after a set amount of time.  Requires 1 pet control slot.", 57, 2297, 50, 80.1, "BP,BM,MR,NS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Resurrection", "Resurrects a player's ghost.  Cannot be used on NPC's or monsters.", 58, 2298, 50, 80.1, "BM,GA,GI", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Air Elemental", "An air elemental is summoned to serve the Caster.  Requires 2 pet control slots.", 59, 2299, 50, 80.1, "BM,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Summon Daemon", "A daemon is summoned to server the Caster.  Results in a large Karma loss for the Caster.  Requires 5 pet control slots.", 60, 2300, 50, 80.1, "BM,MR,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Earth Elemental", "An earth elemental is summoned to serve the Caster.  Requires 2 pet control slots.", 61, 2301, 50, 80.1, "BM,MR,SS", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Fire Elemental", "A fire elemental is summoned to serve the Caster.  Requires 4 pet control slots.", 62, 2302, 50, 80.1, "BM,MR,SS,SA", SchoolFlag.Magery ) );
            SpellList.Add( new FSBSpellInfo( "Water Elemental", "A water elemental is summoned to serve the Caster.  Requires 3 pet control slots.", 63, 2303, 50, 80.1, "BM,MR,SS", SchoolFlag.Magery ) );

            //Necromancy
            SpellList.Add( new FSBSpellInfo( "Animate Dead", "Animates the Targeted corpse, creating a mindless, wandering undead.  The strength of the risen undead is greatly modified by the Fame of the original creature.", 100, 20480, 23, 40, "GD,DB", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Blood Oath", "Temporarily creates a dark pact between the Caster and the Target.  Any damage dealt by the Target to the Caster is increased, but the Target receives the same amount of damage.", 101, 20481, 13, 20, "DB", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Corpse Skin", "Transmogrifies the flesh of the Target creature or player to resemble rotted corpse flesh, making them more vulnerable to Fire and Poison damage, but increasing their Resistance to Physical and Cold damage.", 102, 20482, 11, 20, "BW,GD", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Curse Weapon", "Temporarily imbues a weapon with a life draining effect.", 103, 20483, 7, 0, "PI", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Evil Omen", "Curses the Target so that the next harmful event that affects them is magnified.", 104, 20484, 11, 20, "BW,NC", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Horrific Beast", "Transforms the Caster into a horrific demonic beast, wich deals more damage, and recovers hit points faster, but can no longer cast any spells except for Necromancer Transformation spells.  Caster remains in this form until they recast the Horrific Beast spell.", 105, 20485, 11, 40, "BW,DB", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Lich Form", "Transforms the Caster into a lich, increasing their mana regeneration and some Resistances, while lowering their Fire Resist and slowly sapping their life.  Caster remains in this form until they recast the Lich Form spell.", 106, 20486, 23, 70, "GD,DB,NC", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Mind Rot", "Attempts to place a curse on the Target that increases the mana cost of any spells they cast, for a duration bassed off a comparison between the Caster's Spirit Speak skill and the Target's Resisting Spells skill.", 107, 20487, 17, 30, "BW,DB,PI", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Pain Spike", "Temporarily causes intense physical pain to the Target, dealing Direct damage.  Once the spell wears off, if the Target is still alive, some of the Hit Points lost through the Pain Spike are restored.", 108, 20488, 5, 20, "GD,PI", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Poison Strike", "Creates a blast of poisonous energy centered on the Target.  The main Target is inflicted with a large amount of Poison damage, and all valid Targets in a radius around the main Target are inflicted with a lesser effect.", 109, 20489, 17, 50, "NC", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Strangle", "Temporarily chokes off the air supply of the Target with poisonous fumes.  The Target is inflicted with Poison damage over time.  The amount of damage dealt each 'hit' is based off of the Caster's Spirit Speak skill and the Target's current Stamina.", 110, 20490, 29, 65, "DB,NC", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Summon Familiar", "Allows the Caster to summon a Familiar from a selecetd list.  A Familiar will follow and fight with its owner, in addition to granting unique bonuses to the Caster, dependent upon the type of Familiar summoned.", 111, 20491, 17, 30, "BW,GD,DB", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Vampiric Embrace", "Transforms the Caster into a powerful Vampire, wich increases his Stamina and Mana regeration while lowering his Fire Resistance.  Vampires also perform Life Drain when striking their enemies.  Caster remains in this form untill they recast the Vampiric Embrace spell.", 112, 20492, 23, 99, "BW,NC,PI", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Vengeful Spirit", "Summons a vile Spirit wich haunts the Target untill either the Target or the Spirit is dead.  Vengeful Spirits have the ability to track down their Target wherever they may travel.  A Spirit's strength is determined by the Necromancy and Spirit Speak skills of the Caster.", 113, 20493, 41, 80, "BW,GD,PI", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Wither", "Creates a withering frost around the Caster, wich deals Cold Damage to all valid targets in a radius.", 114, 20494, 23, 60, "GD,NC,PI", SchoolFlag.Necro ) );
            SpellList.Add( new FSBSpellInfo( "Wraith Form", "Transforms the Caster into an etheral Wraith, lowering some Elemental Resists, while increasing their physical resists.  Wraith Form also allows the caster to always succeed when using the Recall spell, and causes a Mana Drain effect when hitting enemies.  Caster remains in this form until they recast the Wraith Form spell.", 115, 20495, 17, 20, "NC,PI", SchoolFlag.Necro ) );
			SpellList.Add( new FSBSpellInfo( "Exorcism", "Requires 100 Spirit Speak and relocates any players ghost around the caster to a shrine in that facet. Will only work in a champion spawn region. Works on any ghost in a 15 tile radius of the champ alter and then sent to the closest shrine but only if they no longer have a corpse.", 116, 2261, 30, 37.0, "NC,GD", SchoolFlag.Necro ) );
            
            //Chivalry
            SpellList.Add( new FSBSpellInfo( "Cleanse By Fire", "Cures the target of poisons, but causes the caster to be burned by fire damage.  The amount of fire damage is lessened if the caster has high Karma.", 200, 20736, 10, 5.0, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Close Wounds", "Heals the target of damage.  The caster's Karma affects the amount of damage healed.", 201, 20737, 10, 0, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Consecrate Weapon", "Temporarily enchants the weapon the caster is currently wielding.  The type of damage the weapon inflicts when hitting a target will be converted to the target's worst Resistance type.  Duration of the effect is affected by the caster's Karma.", 202, 20738, 10, 15, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Dispel Evil", "Attempts to dispel evil summoned creatures and cause other evil creatures to flee from combat.  Transformed Necromancers may also take Stamina and Mana Damage.  Caster's Karma and Chivalry, and Target's Fame or Necromancy affect Dispel Chance.", 203, 20739, 15, 35, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Divine Fury", "Temporarily increases the Paladin's swing speed, chance to hit, and damage dealt, while lowering the Paladin's defenses.  Upon casting, the Paladin's Stamina is also refreshed.  Duration of the spell is affected by the Caster's Karma.", 204, 20740, 15, 25, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Enemy Of One", "The next target hit becomes the Paladin's Mortal Enemy.  All damage dealt to that creature type is increased, but the Paladin takes extra damage from all other creature types.  Mortal Enemy creature types will highlight Orange to the Paladin.  Duration of the spell is affected by the Caster's Karma.", 205, 20741, 20, 45, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Holy Light", "Deals energy damage to all valid targets in a radius around the caster.  Amount of damage dealt is affected by Caster's Karma.", 206, 20742, 15, 55, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Noble Sacrifice", "Attempts to Ressurect, Cure, and Heal all targets in a radius around the caster.  If any target is successfully assisted, the Paladin's current Hit points, Mana, and Stamina are greatly reduced.  Amount of damage healed is affected by the Caster's Karma.", 207, 20743, 20, 65, "T.30", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Remove Curse", "Attempts to remove all Curse effects from target.  Curses include Mage spells such as Clumsy, Weaken, Feebleming, and Paralyze, as well as all Necromancer curses.  Chance of removing curse is affected by the Caster's Karma.", 208, 20744, 20, 5, "T.10", SchoolFlag.Chivalry ) );
            SpellList.Add( new FSBSpellInfo( "Sacred Journey", "Targeting a rune or ship key allows the caster to teleport to the marked location.  Caster may not flee from combat in this manner.", 209, 20745, 20, 15, "T.15", SchoolFlag.Chivalry ) );

//Template
//          SpellList.Add( new FSBSpellInfo( "", "", reg, icon, mana, skill, "" ) );
            #endregion  //SpellList
        }

        public static FSBSpellInfo FindSpellInfo( int spellReg )
        {
            FSBSpellInfo si = null;
            bool Found = false;

            for( int i = 0; i < SpellList.Count && !Found; i++ )
            {
                si = SpellList[i] as FSBSpellInfo;
                if( si != null )
                {
                    if( si.SpellReg == spellReg )
                    {
                        Found = true;
                    }
                }
            }
            return si;
        }

//ConvertRegs
        public static ArrayList ConvertRegs( string regs )
        {
            string[] RegAbrv = regs.Split( ',' );
            ArrayList ReturnRegs = new ArrayList();

            string reg = "";
            for( int i = 0; i < RegAbrv.Length && i < 5; i++ )
            {
                reg = RegAbrv[i];
                if( reg.StartsWith( "T." ) )
                {
                    string[] TitheReq = reg.Split( '.' );
                    ReturnRegs.Add( "Tithe: " + TitheReq[1] );
                }

/*********************\ATTENTION/*********************/
/*      If you added new Abreviations above, you     */
/*   will need to add the conversions here as well!  */
/********************\ATTENTION/**********************/
                switch( reg )
                {
                    case( "BP" ):{ReturnRegs.Add("Black Pearl");break;}
                    case( "BM" ):{ReturnRegs.Add("Bloodmoss");break;}
                    case( "GA" ):{ReturnRegs.Add("Garlic");break;}
                    case( "GI" ):{ReturnRegs.Add("Ginseng");break;}
                    case( "MR" ):{ReturnRegs.Add("Mandrake Root");break;}
                    case( "NS" ):{ReturnRegs.Add("Nightshade");break;}
                    case( "SA" ):{ReturnRegs.Add("Sulfurous Ash");break;}
                    case( "SS" ):{ReturnRegs.Add("Spider's Silk");break;}
                    case( "BW" ):{ReturnRegs.Add("Bat Wing");break;}
                    case( "GD" ):{ReturnRegs.Add("Grave Dust");break;}
                    case( "DB" ):{ReturnRegs.Add("Daemon Blood");break;}
                    case( "NC" ):{ReturnRegs.Add("Nox Crystal");break;}
                    case( "PI" ):{ReturnRegs.Add("Pig Iron");break;}
                    case( "PW" ):{ReturnRegs.Add("Petrafied Wood");break;}
                    case( "SW" ):{ReturnRegs.Add("Spring Water");break;}
                    case( "DA" ):{ReturnRegs.Add("Destroying Angel");break;}
                    case( "KI" ):{ReturnRegs.Add("Kindling");break;}
                    default:{ReturnRegs.Add("");break;}
                }
            }
            return ReturnRegs;
        }
//End ConvertRegs
    }
}
