using System;
using System.Collections;
using Server.Items;
using Server.Mobiles;
using Server.Spells;

namespace Server.Spells.FSB
{
	public class FSBKeyword
	{
		private int m_Spell;
		private string m_Keyword;

		public FSBKeyword( int spell, string keyword )
		{
			m_Spell = spell;
			m_Keyword = keyword;
		}

		public int Spell{ get{ return m_Spell; } }
		public string Keyword{ get{ return m_Keyword; } }


		public FSBKeyword( GenericReader reader )
		{
			Deserialize( reader );
		}

		public void Deserialize( GenericReader reader )
		{
			m_Spell = reader.ReadInt();
			m_Keyword = reader.ReadString();
		}

		public void Serialize( GenericWriter writer )
		{
			writer.Write( m_Spell );
			writer.Write( m_Keyword );
		}
	}
}