using System;
using System.Collections;
using Server.Items;
using Server.Mobiles;
using Server.Spells;

namespace Server.Spells.FSB
{
    public class FSBSchoolInfo
    {
        private string m_Name;
        private string m_Range;
        private SchoolFlag m_Flag;
        private bool m_ReqScrolls;
        private bool m_StaffOnly;
        private int m_Background;

        public FSBSchoolInfo( string name, string range, SchoolFlag flag, bool reqScrolls, bool staffOnly, int background )
        {
            m_Name = name;
            m_Range = range;
            m_Flag = flag;
            m_ReqScrolls = reqScrolls;
            m_StaffOnly = staffOnly;
            m_Background = background;
        }

        public string Name{ get{ return m_Name; } }
        public string Range{ get{ return m_Range; } }
        public SchoolFlag School{ get{ return m_Flag; } }
		public bool ReqScrolls{ get{ return m_ReqScrolls; } }
		public bool StaffOnly{ get{ return m_StaffOnly; } }
		public int Background{ get{ return m_Background; } }

        public FSBSchoolInfo( GenericReader reader )
        {
            Deserialize( reader );
        }

        public void Serialize( GenericWriter writer )
        {
            writer.Write( (int)0 );
            writer.Write( m_Name );
            writer.Write( m_Range );
            writer.Write( (int)m_Flag );
            writer.Write( (bool)m_ReqScrolls );
            writer.Write( (bool)m_StaffOnly );
            writer.Write( (int)m_Background );
        }

        public void Deserialize( GenericReader reader )
        {
            int version = reader.ReadInt();
            switch( version )
            {
                case 0:
                {
                    m_Name = reader.ReadString();
                    m_Range = reader.ReadString();
                    m_Flag = (SchoolFlag)reader.ReadInt();
                    m_ReqScrolls = reader.ReadBool();
                    m_StaffOnly = reader.ReadBool();
                    m_Background = reader.ReadInt();
                    break;
                }
            }
        }
    }
}