using System;
using System.Collections;
using Server.Items;
using Server.Mobiles;
using Server.Spells;

namespace Server.Spells.FSB
{
    public class FSBSpellInfo
    {
        private string m_Name;
        private string m_Info;
        private int m_SpellReg;
        private int m_SpellIcon;
        private int m_Mana;
        private double m_Skill;
        private string m_Reagents;
        private SchoolFlag m_Flag;

        public FSBSpellInfo( string name, string info, int spellreg, int spellicon, int mana, double skill, string reagents, SchoolFlag flag )
        {
            m_Name = name;
            m_Info = info;
            m_SpellReg = spellreg;
            m_SpellIcon = spellicon;
            m_Mana = mana;
            m_Skill = skill;
            m_Reagents = reagents;
            m_Flag = flag;
        }

        public string Name{         get{ return m_Name; } }
        public string Info{         get{ return m_Info; } }
        public int SpellReg{        get{ return m_SpellReg; } }
        public int SpellIcon{       get{ return m_SpellIcon; } }
        public int Mana{            get{ return m_Mana; } }
        public double Skill{        get{ return m_Skill; } }
        public string Reagents{     get{ return m_Reagents; } }
        public SchoolFlag School{   get{ return m_Flag; } }

        public FSBSpellInfo( GenericReader reader )
        {
            Deserialize( reader );
        }

        public void Serialize( GenericWriter writer )
        {
            writer.Write( (int)0 );
            writer.Write( m_Name );
            writer.Write( m_Info );
            writer.Write( m_SpellReg );
            writer.Write( m_SpellIcon );
            writer.Write( m_Mana );
            writer.Write( m_Skill );
            writer.Write( m_Reagents );
            writer.Write( (int)m_Flag );
        }

        public void Deserialize( GenericReader reader )
        {
            int version = reader.ReadInt();
            switch( version )
            {
                case 0:
                {
                    m_Name = reader.ReadString();
                    m_Info = reader.ReadString();
                    m_SpellReg = reader.ReadInt();
                    m_SpellIcon = reader.ReadInt();
                    m_Mana = reader.ReadInt();
                    m_Skill = reader.ReadDouble();
                    m_Reagents = reader.ReadString();
                    m_Flag = (SchoolFlag)reader.ReadInt();
                    break;
                }
            }
        }
    }
}