using System;
using Server;

namespace Server.Spells.FSB
{
	public class IconInfo
	{
		public int Icon;
		public int Spell;
		public int X;
		public int Y;
		public int Background;

		public IconInfo( int icon, int spell, int x, int y, int background )
		{
			Icon = icon;
			Spell = spell;
			X = x;
			Y = y;
			Background = background;
		}

		public IconInfo( GenericReader reader )
		{
			Deserialize( reader );
		}

		public void Serialize( GenericWriter writer )
		{
			writer.Write( (int)1 );
			writer.Write( Background );
			writer.Write( Icon );
			writer.Write( Spell );
			writer.Write( X );
			writer.Write( Y );
		}

		public void Deserialize( GenericReader reader )
		{
			int version = reader.ReadInt();
			switch( version )
			{
				case 1:
				{
					Background = reader.ReadInt();
					goto case 0;
				}
				case 0:
				{
					Icon = reader.ReadInt();
					Spell = reader.ReadInt();
					X = reader.ReadInt();
					Y = reader.ReadInt();
					break;
				}
			}
		}
	}
}