/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
All Spells Optional Restrictive System created by Alien, Daat99 and Lucid Nagual.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~     Version [5].0 & Above   _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using System.Collections;
using System.Collections.Generic;
using Server;
using Server.Items;
using Server.Gumps;
using Server.Network;
using Server.Misc;
using Server.ContextMenus;
using Server.Targeting;
using Server.LucidNagual;


namespace Server.Mobiles
{
	public class MagicsAndSkillTrainer : BaseVendor
	{
		private ArrayList m_SBInfos = new ArrayList();
		protected override ArrayList SBInfos{ get { return m_SBInfos; } }
		public override bool ClickTitle{ get{ return true; } }
		public override bool IsActiveBuyer{ get{ return true; } }
		public override bool OnBuyItems( Mobile buyer, ArrayList list )
		{
			return false;
		}
		public static readonly object From = new object();
		public static readonly object Vendor = new object();
		public static readonly object Price = new object();
		private bool m_CanRes;
		public override NpcGuild NpcGuild{ get{ return NpcGuild.None; } }
		public override bool CanTeach{ get{ return true; } }
		
		public override void VendorBuy( Mobile from )
		{
			from.SendGump( new ClassGump( from ) );
		}
		
		[CommandProperty( AccessLevel.GameMaster )]
		public bool CanRessurect
		{
			get { return m_CanRes; }
			set { m_CanRes = value; }
		}
		
		[Constructable]
		public MagicsAndSkillTrainer() : base( "a Magics Trainer" )
		{
			SpeechHue = Utility.RandomDyedHue();
			Title = "a Magics and Skill Trainer";
			Hue = Utility.RandomSkinHue();
			
			SetSkill( SkillName.AnimalLore, 85.0, 100.0 );
			SetSkill( SkillName.AnimalTaming, 55.0, 78.0 );
			SetSkill( SkillName.Camping, 55.0, 78.0 );
			SetSkill( SkillName.Herding, 64.0, 100.0 );
			SetSkill( SkillName.Tracking, 36.0, 68.0 );
			SetSkill( SkillName.Veterinary, 60.0, 83.0 );
			SetSkill( SkillName.MagicResist, 25.0, 47.5 );
			SetSkill( SkillName.Wrestling, 100.0, 115.3 );
			
			
			if ( this.Female = Utility.RandomBool() )
			{
				Body = 0x191;
				Name = NameList.RandomName( "female" );
				
				Item GnarledStaff = new GnarledStaff();
				GnarledStaff.Movable = false;
				
				AddItem( GnarledStaff );
				
				AddItem( new Sandals() );
				AddItem( new MagicTrainerRobe() );
			}
			else
			{
				Body = 0x190;
				Name = NameList.RandomName( "male" );
				
				GnarledStaff GnarledStaff = new GnarledStaff();
				GnarledStaff.Movable = false;
				
				AddItem( GnarledStaff );
				AddItem( new Sandals() );
				AddItem( new MagicTrainerRobe() );
			}
			
			SetStr( 90, 100 );
			SetDex( 90, 95 );
			SetInt( 40, 65 );
			SetHits( 200, 350 );
			
			SetDamage( 20, 32 );
			
			Fame = 1000;
			Karma = -3000;
			
			Item hair = new Item( Utility.RandomList( 0x203B, 0x2049, 0x2048, 0x204A ) );
			hair.Hue = Utility.RandomNondyedHue();
			hair.Layer = Layer.Hair;
			hair.Movable = false;
			AddItem( hair );
		}
		
		private DateTime m_NextResurrect;
		private static TimeSpan ResurrectDelay = TimeSpan.FromSeconds( 2.0 );
		
		public override void OnMovement( Mobile m, Point3D oldLocation )
		{
			if ( m_CanRes )
			{
				if ( !m.Frozen && !m.Alive && DateTime.Now >= m_NextResurrect && InRange( m, 4 ) && !InRange( oldLocation, 4 ) && InLOS( m ) )
				{
					m_NextResurrect = DateTime.Now + ResurrectDelay;
					
					if ( m.Map == null || !m.Map.CanFit( m.Location, 16, false, false ) )
					{
						m.SendLocalizedMessage( 502391 ); // Thou can not be resurrected there!
					}
					else
					{
						Direction = GetDirectionTo( m );
						Say( 501224 ); // Thou hast strayed from the path of virtue, but thou still deservest a second chance.
						
						m.PlaySound( 0x214 );
						m.FixedEffect( 0x376A, 10, 16 );
						
						m.CloseGump( typeof( ResurrectGump ) );
						m.SendGump( new ResurrectGump( m, ResurrectMessage.Healer ) );
					}
				}
			}
		}
		
		public void OnClick( Mobile from )
		{
			from.SendGump( new ClassGump( from ) );
		}
		
		public override void InitSBInfo()
		{
		}
		
		public MagicsAndSkillTrainer( Serial serial ) : base( serial )
		{
		}
		
		//--Stable Start------------------------------------------------------------------
		private class StableEntry : ContextMenuEntry
		{
			private MagicsAndSkillTrainer m_Trainer;
			private Mobile m_From;
			
			public StableEntry( MagicsAndSkillTrainer trainer, Mobile from ) : base( 6126, 12 )
			{
				m_Trainer = trainer;
				m_From = from;
			}
			
			public override void OnClick()
			{
				m_Trainer.BeginStable( m_From );
			}
		}
		
		private class ClaimListGump : Gump
		{
			private MagicsAndSkillTrainer m_Trainer;
			private Mobile m_From;
			private ArrayList m_List;
			
			public ClaimListGump( MagicsAndSkillTrainer trainer, Mobile from, ArrayList list ) : base( 50, 50 )
			{
				m_Trainer = trainer;
				m_From = from;
				m_List = list;
				
				from.CloseGump( typeof( ClaimListGump ) );
				
				AddPage( 0 );
				
				AddBackground( 0, 0, 325, 50 + (list.Count * 20), 9250 );
				AddAlphaRegion( 5, 5, 315, 40 + (list.Count * 20) );
				
				AddHtml( 15, 15, 275, 20, "<BASEFONT COLOR=#FFFFFF>Select a pet to retrieve from the stables:</BASEFONT>", false, false );
				
				for ( int i = 0; i < list.Count; ++i )
				{
					BaseCreature pet = list[i] as BaseCreature;
					
					if ( pet == null || pet.Deleted )
						continue;
					
					AddButton( 15, 39 + (i * 20), 10006, 10006, i + 1, GumpButtonType.Reply, 0 );
					AddHtml( 32, 35 + (i * 20), 275, 18, String.Format( "<BASEFONT COLOR=#C0C0EE>{0}</BASEFONT>", pet.Name ), false, false );
				}
			}
			
			public override void OnResponse( NetState sender, RelayInfo info )
			{
				int index = info.ButtonID - 1;
				
				if ( index >= 0 && index < m_List.Count )
					m_Trainer.EndClaimList( m_From, m_List[index] as BaseCreature );
			}
		}
		
		private class ClaimAllEntry : ContextMenuEntry
		{
			private MagicsAndSkillTrainer m_Trainer;
			private Mobile m_From;
			
			public ClaimAllEntry( MagicsAndSkillTrainer trainer, Mobile from ) : base( 6127, 12 )
			{
				m_Trainer = trainer;
				m_From = from;
			}
			
			public override void OnClick()
			{
				m_Trainer.Claim( m_From );
			}
		}
		
		public override void AddCustomContextEntries( Mobile from, List<ContextMenuEntry> list )
		{
			if ( from.Alive )
			{
				list.Add( new StableEntry( this, from ) );
				
				if ( from.Stabled.Count > 0 )
					list.Add( new ClaimAllEntry( this, from ) );
			}
			
			base.AddCustomContextEntries( from, list );
		}
		
		public static int GetMaxStabled( Mobile from )
		{
			double taming = from.Skills[SkillName.AnimalTaming].Value;
			double anlore = from.Skills[SkillName.AnimalLore].Value;
			double vetern = from.Skills[SkillName.Veterinary].Value;
			double sklsum = taming + anlore + vetern;
			
			int max;
			
			if ( sklsum >= 240.0 )
				max = 5;
			else if ( sklsum >= 200.0 )
				max = 4;
			else if ( sklsum >= 160.0 )
				max = 3;
			else
				max = 2;
			
			if ( taming >= 100.0 )
				max += (int)((taming - 90.0) / 10);
			
			if ( anlore >= 100.0 )
				max += (int)((anlore - 90.0) / 10);
			
			if ( vetern >= 100.0 )
				max += (int)((vetern - 90.0) / 10);
			
			return max;
		}
		
		private class StableTarget : Target
		{
			private MagicsAndSkillTrainer m_Trainer;
			
			public StableTarget( MagicsAndSkillTrainer trainer ) : base( 12, false, TargetFlags.None )
			{
				m_Trainer = trainer;
			}
			
			protected override void OnTarget( Mobile from, object targeted )
			{
				if ( targeted is BaseCreature )
					m_Trainer.EndStable( from, (BaseCreature)targeted );
				else if ( targeted == from )
					m_Trainer.SayTo( from, 502672 ); // HA HA HA! Sorry, I am not an inn.
				else
					m_Trainer.SayTo( from, 1048053 ); // You can't stable that!
			}
		}
		
		public void BeginClaimList( Mobile from )
		{
			if ( Deleted || !from.CheckAlive() )
				return;
			
			ArrayList list = new ArrayList();
			
			for ( int i = 0; i < from.Stabled.Count; ++i )
			{
				BaseCreature pet = from.Stabled[i] as BaseCreature;
				
				if ( pet == null || pet.Deleted )
				{
					pet.IsStabled = false;
					from.Stabled.RemoveAt( i );
					--i;
					continue;
				}
				
				list.Add( pet );
			}
			
			if ( list.Count > 0 )
				from.SendGump( new ClaimListGump( this, from, list ) );
			else
				SayTo( from, 502671 ); // But I have no animals stabled with me at the moment!
		}
		
		public void EndClaimList( Mobile from, BaseCreature pet )
		{
			if ( pet == null || pet.Deleted || from.Map != this.Map || !from.InRange( this, 14 ) || !from.Stabled.Contains( pet ) || !from.CheckAlive() )
				return;
			
			if ( (from.Followers + pet.ControlSlots) <= from.FollowersMax )
			{
				pet.SetControlMaster( from );
				
				if ( pet.Summoned )
					pet.SummonMaster = from;
				
				pet.ControlTarget = from;
				pet.ControlOrder = OrderType.Follow;
				
				pet.MoveToWorld( from.Location, from.Map );
				
				pet.IsStabled = false;
				from.Stabled.Remove( pet );
				
				SayTo( from, 1042559 ); // Here you go... and good day to you!
			}
			else
			{
				SayTo( from, 1049612, pet.Name ); // ~1_NAME~ remained in the stables because you have too many followers.
			}
		}
		
		public void BeginStable( Mobile from )
		{
			if ( Deleted || !from.CheckAlive() )
				return;
			
			if ( from.Stabled.Count >= GetMaxStabled( from ) )
			{
				SayTo( from, 1042565 ); // You have too many pets in the stables!
			}
			else
			{
				SayTo( from, 1042558 ); /* I charge 30 gold per pet for a real week's stable time.
				 * I will withdraw it from thy bank account.
				 * Which animal wouldst thou like to stable here?
				 */
				
				from.Target = new StableTarget( this );
			}
		}
		
		public void EndStable( Mobile from, BaseCreature pet )
		{
			if ( Deleted || !from.CheckAlive() )
				return;
			
			if ( !pet.Controlled || pet.ControlMaster != from )
			{
				SayTo( from, 1042562 ); // You do not own that pet!
			}
			else if ( pet.IsDeadPet )
			{
				SayTo( from, 1049668 ); // Living pets only, please.
			}
			else if ( pet.Summoned )
			{
				SayTo( from, 502673 ); // I can not stable summoned creatures.
			}
			else if ( pet.Body.IsHuman )
			{
				SayTo( from, 502672 ); // HA HA HA! Sorry, I am not an inn.
			}
			else if ( (pet is PackLlama || pet is PackHorse || pet is Beetle) && (pet.Backpack != null && pet.Backpack.Items.Count > 0) )
			{
				SayTo( from, 1042563 ); // You need to unload your pet.
			}
			else if ( pet.Combatant != null && pet.InRange( pet.Combatant, 12 ) && pet.Map == pet.Combatant.Map )
			{
				SayTo( from, 1042564 ); // I'm sorry.  Your pet seems to be busy.
			}
			else if ( from.Stabled.Count >= GetMaxStabled( from ) )
			{
				SayTo( from, 1042565 ); // You have too many pets in the stables!
			}
			else
			{
				Container bank = from.BankBox;
				
				if ( bank != null && bank.ConsumeTotal( typeof( Gold ), 30 ) )
				{
					pet.ControlTarget = null;
					pet.ControlOrder = OrderType.Stay;
					pet.Internalize();
					
					pet.SetControlMaster( null );
					pet.SummonMaster = null;
					
					pet.IsStabled = true;
					from.Stabled.Add( pet );
					
					SayTo( from, 502679 ); // Very well, thy pet is stabled. Thou mayst recover it by saying 'claim' to me. In one real world week, I shall sell it off if it is not claimed!
				}
				else
				{
					SayTo( from, 502677 ); // But thou hast not the funds in thy bank account!
				}
			}
		}
		
		public void Claim( Mobile from )
		{
			if ( Deleted || !from.CheckAlive() )
				return;
			
			bool claimed = false;
			int stabled = 0;
			
			for ( int i = 0; i < from.Stabled.Count; ++i )
			{
				BaseCreature pet = from.Stabled[i] as BaseCreature;
				
				if ( pet == null || pet.Deleted )
				{
					pet.IsStabled = false;
					from.Stabled.RemoveAt( i );
					--i;
					continue;
				}
				
				++stabled;
				
				if ( (from.Followers + pet.ControlSlots) <= from.FollowersMax )
				{
					pet.SetControlMaster( from );
					
					if ( pet.Summoned )
						pet.SummonMaster = from;
					
					pet.ControlTarget = from;
					pet.ControlOrder = OrderType.Follow;
					
					pet.MoveToWorld( from.Location, from.Map );
					
					pet.IsStabled = false;
					from.Stabled.RemoveAt( i );
					--i;
					
					claimed = true;
				}
				else
				{
					SayTo( from, 1049612, pet.Name ); // ~1_NAME~ remained in the stables because you have too many followers.
				}
			}
			
			if ( claimed )
				SayTo( from, 1042559 ); // Here you go... and good day to you!
			else if ( stabled == 0 )
				SayTo( from, 502671 ); // But I have no animals stabled with me at the moment!
		}
		
		public override bool HandlesOnSpeech( Mobile from )
		{
			if ( from.InRange( this.Location, 12 ) )
				return true;
			
			return base.HandlesOnSpeech( from );
		}
		
		
		public override void OnSpeech( SpeechEventArgs e )
		{
			if ( !e.Handled && e.HasKeyword( 0x0008 ) )
			{
				e.Handled = true;
				BeginStable( e.Mobile );
			}
			else if ( !e.Handled && e.HasKeyword( 0x0009 ) )
			{
				e.Handled = true;
				
				if ( !Insensitive.Equals( e.Speech, "claim" ) )
					BeginClaimList( e.Mobile );
				else
					Claim( e.Mobile );
			}
			else
			{
				base.OnSpeech( e );
			}
			
			if ( !e.Handled && e.Mobile.InRange( this.Location, 12 ) )
			{
				for ( int i = 0; i < e.Keywords.Length; ++i )
				{
					int keyword = e.Keywords[i];
					
					switch ( keyword )
					{
						case 0x0000: // *withdraw*
							{
								e.Handled = true;
								
								if ( e.Mobile.Criminal )
								{
									this.Say( 500389 ); // I will not do business with a criminal!
									break;
								}
								
								string[] split = e.Speech.Split( ' ' );
								
								if ( split.Length >= 2 )
								{
									int amount;
									
									try
									{
										amount = Convert.ToInt32( split[1] );
									}
									catch
									{
										break;
									}
									
									if ( amount > 5000 )
									{
										this.Say( 500381 ); // Thou canst not withdraw so much at one time!
									}
									else if ( amount > 0 )
									{
										BankBox box = e.Mobile.BankBox;
										
										if ( box == null || !box.ConsumeTotal( typeof( Gold ), amount ) )
										{
											this.Say( 500384 ); // Ah, art thou trying to fool me? Thou hast not so much gold!
										}
										else
										{
											e.Mobile.AddToBackpack( new Gold( amount ) );
											
											this.Say( 1010005 ); // Thou hast withdrawn gold from thy account.
										}
									}
								}
								
								break;
							}
						case 0x0001: // *balance*
							{
								e.Handled = true;
								
								if ( e.Mobile.Criminal )
								{
									this.Say( 500389 ); // I will not do business with a criminal!
									break;
								}
								
								BankBox box = e.Mobile.BankBox;
								
								if ( box != null )
								{
									this.Say( 1042759, box.TotalGold.ToString() ); // Thy current bank balance is ~1_AMOUNT~ gold.
								}
								
								break;
							}
						case 0x0002: // *bank*
							{
								e.Handled = true;
								
								if ( e.Mobile.Criminal )
								{
									this.Say( 500378 ); // Thou art a criminal and cannot access thy bank box.
									break;
								}
								
								BankBox box = e.Mobile.BankBox;
								
								if ( box != null )
									box.Open();
								
								break;
							}
						case 0x0003: // *check*
							{
								e.Handled = true;
								
								if ( e.Mobile.Criminal )
								{
									this.Say( 500389 ); // I will not do business with a criminal!
									break;
								}
								
								string[] split = e.Speech.Split( ' ' );
								
								if ( split.Length >= 2 )
								{
									int amount;
									
									try
									{
										amount = Convert.ToInt32( split[1] );
									}
									catch
									{
										break;
									}
									
									if ( amount < 5000 )
									{
										this.Say( 1010006 ); // We cannot create checks for such a paltry amount of gold!
									}
									else if ( amount > 1000000 )
									{
										this.Say( 1010007 ); // Our policies prevent us from creating checks worth that much!
									}
									else
									{
										BankCheck check = new BankCheck( amount );
										
										BankBox box = e.Mobile.BankBox;
										
										if ( box == null || !box.TryDropItem( e.Mobile, check, false ) )
										{
											this.Say( 500386 ); // There's not enough room in your bankbox for the check!
											check.Delete();
										}
										else if ( !box.ConsumeTotal( typeof( Gold ), amount ) )
										{
											this.Say( 500384 ); // Ah, art thou trying to fool me? Thou hast not so much gold!
											check.Delete();
										}
										else
										{
											this.Say( 1042673, AffixType.Append, amount.ToString(), "" ); // Into your bank box I have placed a check in the amount of:
										}
									}
								}
								
								break;
							}
					}
				}
			}
		}
		//--Stable End-----------------------------------------------------------------
		
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
		}
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}


