/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
All Spells Optional Restrictive System created by Alien, Daat99 and Lucid Nagual.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~     Version [5].0 & Above   _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using Server.Mobiles;
using Server.Network;
using Server.Prompts;
using Server.Items;
using Server.Targeting;
using Server.Gumps;

namespace Server.Items
{
	public class PowerScrollDeed : Item
	{
	 	[Constructable]
		public PowerScrollDeed() : base( 0x14F0 )
		{
			Weight = 1.0;
			LootType = LootType.Blessed;
			Name = "PowerScrollDeed";
			Hue = 1153;
		}
		
		public PowerScrollDeed( Serial serial ) : base( serial )
		{
		}
		
		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			
			writer.Write( (int) 0 ); // version
		}
		
		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
		
		public override void OnDoubleClick( Mobile from )
		{
			if ( !IsChildOf( from.Backpack ) )
				from.SendLocalizedMessage( 1042001 ); // That must be in your pack for you to use it.
			
		/*	Item item = from.Backpack.FindItemByType(typeof( NomadOrb ));
			
			if (item == null) //If item is found.
			{
				from.SendMessage( "Nomads cannot use this." );
				return;
			}
			
			from.Backpack.FindItemByType(typeof( CannibalOrb ));
			
			if (item == null) //If item is found.
			{
				from.SendMessage( "Cannabils cannot use this." );
				return;
			}*/
			
			else
				from.SendGump( new InternalGump( from, this ) );
		}
		
		private class InternalGump : Gump
		{
			private Mobile m_From;
			private PowerScrollDeed m_Deed;
			
			public InternalGump( Mobile from, PowerScrollDeed deed ) : base( 50, 50 )
			{
				m_From = from;
				m_Deed = deed;
				
				from.CloseGump( typeof( InternalGump ) );
				
				AddBackground( 10, 10, 435, 435, 0xA28 );
				AddItem(320, 360, 5360, 1152);
				//AddItem(337, 348, 6377, 0);
				AddImage(413,56, 10441);
				//AddButton( 175, 340, 0xFA5, 0xFA7, 0x0, GumpButtonType.Reply, 0 ); // CANCEL
				
				AddLabel(180, 25, 0, "Power Scrolls");
				
				AddLabel(75, 55, 0, "Blacksmith");
				AddLabel(75, 85, 0, "Tailoring");
				AddLabel(75, 115, 0, "Swords");
				AddLabel(75, 145, 0, "Fencing");
				AddLabel(75, 175, 0, "Macing");
				AddLabel(75, 205, 0, "Archery");
				AddLabel(75, 235, 0, "Wrestling");
				AddLabel(75, 265, 0, "Parry");
				AddLabel(75, 295, 0, "Tactics");
				AddLabel(75, 325, 0, "Anatomy");
				
				AddLabel(205, 55, 0, "Healing");
				AddLabel(205, 85, 0, "Magery");
				AddLabel(205, 115, 0, "Meditation");
				AddLabel(205, 145, 0, "EvalInt");
				AddLabel(205, 175, 0, "MagicResist");
				AddLabel(205, 205, 0, "AnimalTaming");
				AddLabel(205, 235, 0, "AnimalLore");
				AddLabel(205, 265, 0, "Veterinary");
				AddLabel(205, 295, 0, "Musicianship");
				AddLabel(205, 325, 0, "Provocation");
				
				AddLabel(335, 55, 0, "Discordance");
				AddLabel(335, 85, 0, "Peacemaking");
				AddLabel(335, 115, 0, "Chivalry");
				AddLabel(335, 145, 0, "Focus");
				AddLabel(335, 175, 0, "Necromancy");
				AddLabel(335, 205, 0, "Stealing");
				AddLabel(335, 235, 0, "Stealth");
				AddLabel(335, 265, 0, "SpiritSpeak");
				
				AddButton( 40, 53, 0xFA5, 0xFA7, 1, GumpButtonType.Reply, 0 );
				AddButton( 40, 83, 0xFA5, 0xFA7, 2, GumpButtonType.Reply, 0 );
				AddButton( 40, 113, 0xFA5, 0xFA7, 3, GumpButtonType.Reply, 0 );
				AddButton( 40, 143, 0xFA5, 0xFA7, 4, GumpButtonType.Reply, 0 );
				AddButton( 40, 173, 0xFA5, 0xFA7, 5, GumpButtonType.Reply, 0 );
				AddButton( 40, 203, 0xFA5, 0xFA7, 6, GumpButtonType.Reply, 0 );
				AddButton( 40, 233, 0xFA5, 0xFA7, 7, GumpButtonType.Reply, 0 );
				AddButton( 40, 263, 0xFA5, 0xFA7, 8, GumpButtonType.Reply, 0 );
				AddButton( 40, 293, 0xFA5, 0xFA7, 9, GumpButtonType.Reply, 0 );
				AddButton( 40, 323, 0xFA5, 0xFA7, 10, GumpButtonType.Reply, 0 );
				
				AddButton( 170, 53, 0xFA5, 0xFA7, 11, GumpButtonType.Reply, 0 );
				AddButton( 170, 83, 0xFA5, 0xFA7, 12, GumpButtonType.Reply, 0 );
				AddButton( 170, 113, 0xFA5, 0xFA7, 13, GumpButtonType.Reply, 0 );
				AddButton( 170, 143, 0xFA5, 0xFA7, 14, GumpButtonType.Reply, 0 );
				AddButton( 170, 173, 0xFA5, 0xFA7, 15, GumpButtonType.Reply, 0 );
				AddButton( 170, 203, 0xFA5, 0xFA7, 16, GumpButtonType.Reply, 0 );
				AddButton( 170, 233, 0xFA5, 0xFA7, 17, GumpButtonType.Reply, 0 );
				AddButton( 170, 263, 0xFA5, 0xFA7, 18, GumpButtonType.Reply, 0 );
				AddButton( 170, 293, 0xFA5, 0xFA7, 19, GumpButtonType.Reply, 0 );
				AddButton( 170, 323, 0xFA5, 0xFA7, 20, GumpButtonType.Reply, 0 );
				
				AddButton( 300, 53, 0xFA5, 0xFA7, 21, GumpButtonType.Reply, 0 );
				AddButton( 300, 83, 0xFA5, 0xFA7, 22, GumpButtonType.Reply, 0 );
				AddButton( 300, 113, 0xFA5, 0xFA7, 23, GumpButtonType.Reply, 0 );
				AddButton( 300, 143, 0xFA5, 0xFA7, 24, GumpButtonType.Reply, 0 );
				AddButton( 300, 173, 0xFA5, 0xFA7, 25, GumpButtonType.Reply, 0 );
				AddButton( 300, 203, 0xFA5, 0xFA7, 26, GumpButtonType.Reply, 0 );
				AddButton( 300, 233, 0xFA5, 0xFA7, 27, GumpButtonType.Reply, 0 );
				AddButton( 300, 263, 0xFA5, 0xFA7, 28, GumpButtonType.Reply, 0 );
			}
			
			public override void OnResponse( NetState sender, RelayInfo info )
			{
				if ( m_Deed.Deleted )
					return;
				
				Item pscroll = null;
				
				switch ( info.ButtonID )
				{
						case 0: return;
						case 1: pscroll = new PowerScroll ( PowerScroll.Skills[0], 120.0 ) ; break;
						case 2: pscroll = new PowerScroll ( PowerScroll.Skills[1], 120.0 ) ; break;
						case 3: pscroll = new PowerScroll ( PowerScroll.Skills[2], 120.0 ) ; break;
						case 4: pscroll = new PowerScroll ( PowerScroll.Skills[3], 120.0 ) ; break;
						case 5: pscroll = new PowerScroll ( PowerScroll.Skills[4], 120.0 ) ; break;
						case 6: pscroll = new PowerScroll ( PowerScroll.Skills[5], 120.0 ) ; break;
						case 7: pscroll = new PowerScroll ( PowerScroll.Skills[6], 120.0 ) ; break;
						case 8: pscroll = new PowerScroll ( PowerScroll.Skills[7], 120.0 ) ; break;
						case 9: pscroll = new PowerScroll ( PowerScroll.Skills[8], 120.0 ) ; break;
						case 10: pscroll = new PowerScroll ( PowerScroll.Skills[9], 120.0 ) ; break;
						
						case 11: pscroll = new PowerScroll ( PowerScroll.Skills[10], 120.0 ) ; break;
						case 12: pscroll = new PowerScroll ( PowerScroll.Skills[11], 120.0 ) ; break;
						case 13: pscroll = new PowerScroll ( PowerScroll.Skills[12], 120.0 ) ; break;
						case 14: pscroll = new PowerScroll ( PowerScroll.Skills[13], 120.0 ) ; break;
						case 15: pscroll = new PowerScroll ( PowerScroll.Skills[14], 120.0 ) ; break;
						case 16: pscroll = new PowerScroll ( PowerScroll.Skills[15], 120.0 ) ; break;
						case 17: pscroll = new PowerScroll ( PowerScroll.Skills[16], 120.0 ) ; break;
						case 18: pscroll = new PowerScroll ( PowerScroll.Skills[17], 120.0 ) ; break;
						case 19: pscroll = new PowerScroll ( PowerScroll.Skills[18], 120.0 ) ; break;
						case 20: pscroll = new PowerScroll ( PowerScroll.Skills[19], 120.0 ) ; break;
						
						case 21: pscroll = new PowerScroll ( PowerScroll.Skills[20], 120.0 ) ; break;
						case 22: pscroll = new PowerScroll ( PowerScroll.Skills[21], 120.0 ) ; break;
						case 23: pscroll = new PowerScroll ( PowerScroll.Skills[22], 120.0 ) ; break;
						case 24: pscroll = new PowerScroll ( PowerScroll.Skills[23], 120.0 ) ; break;
						case 25: pscroll = new PowerScroll ( PowerScroll.Skills[24], 120.0 ) ; break;
						case 26: pscroll = new PowerScroll ( PowerScroll.Skills[25], 120.0 ) ; break;
						case 27: pscroll = new PowerScroll ( PowerScroll.Skills[26], 120.0 ) ; break;
						case 28: pscroll = new PowerScroll ( PowerScroll.Skills[27], 120.0 ) ; break;
				}
			
				if ( pscroll != null )
				{
					m_From.Backpack.DropItem( pscroll );
					//m_From.AddItem( pscroll );
				}
				
				m_Deed.Delete();
			}
		}
	}
}
