//Edited by: Lucid Nagual
using System;
using System.Collections;
using Server;
using Server.Items;
using Server.Mobiles;
using Server.Gumps;
using Server.Prompts;
using Server.Targeting;
using Server.Misc;
using Server.Multis;
using Server.ContextMenus;
using Server.Network;


namespace Server.Gumps
{
	public class RegBookGump : Server.Gumps.Gump
	{
		private Mobile m_Player;
		private RegBook m_RegBook;
		
		public RegBookGump( Mobile player, RegBook regbook ) : base( 10, 10 )
		{
			m_Player = player;
			m_RegBook = regbook;
			this.Closable=true;
			this.Disposable=true;
			this.Dragable=true;
			this.Resizable=false;
			this.AddPage(0);
			this.AddImage(-2, 0, 500);
			
			//--<<Reagent Art>>------------------[Start]
			this.AddItem(20, 10, 3976);  //NightShade
			this.AddItem(23, 35, 3962);  //BlackPearl
			this.AddItem(20, 50, 3963);  //BloodMoss
			this.AddItem(25, 70, 3972);  //Garlic
			this.AddItem(20, 90, 3973);  //Ginseng
			this.AddItem(20, 110, 3974); //MandrakeRoot
			this.AddItem(20, 130, 3980); //SulfurousAsh
			this.AddItem(20, 150, 3981); //SpidersSilk
			this.AddItem(20, 170, 3982); //NoxCrystal
			this.AddItem(20, 190, 3983); //GraveDust
			//--<<Reagent Art>>------------------[End]
			
			//--<<Amount Of Reagents In Book>>------------------[Start]
			this.AddLabel(70, 10, 900, 		String.Format( "{0}", m_RegBook.m_NightShade ) );
			this.AddLabel(70, 30, 900, 		String.Format( "{0}", m_RegBook.m_BlackPearl ) );
			this.AddLabel(70, 50, 900, 		String.Format( "{0}", m_RegBook.m_BloodMoss ) );
			this.AddLabel(70, 70, 900, 		String.Format( "{0}", m_RegBook.m_Garlic ) );
			this.AddLabel(70, 90, 900, 		String.Format( "{0}", m_RegBook.m_Ginseng ) );
			this.AddLabel(70, 110, 900, 	String.Format( "{0}", m_RegBook.m_MandrakeRoot ) );
			this.AddLabel(70, 130, 900, 	String.Format( "{0}", m_RegBook.m_SulfurousAsh ) );
			this.AddLabel(70, 150, 900, 	String.Format( "{0}", m_RegBook.m_SpidersSilk ) );
			this.AddLabel(70, 170, 900, 	String.Format( "{0}", m_RegBook.m_NoxCrystal ) );
			this.AddLabel(70, 190, 900, 	String.Format( "{0}", m_RegBook.m_GraveDust ) );
			//--<<Amount Of Reagents In Book>>------------------[End]
			
			//--<<Reagent Art>>------------------[Start]
			this.AddItem(210, 10, 3965);  //DaemonBlood
			this.AddItem(210, 30, 3960);  //BatWing
			this.AddItem(210, 50, 3978);  //PigIron
			this.AddItem(210, 70, 3620);  //SpringWater
			this.AddItem(210, 90, 3615);  //DestroyingAngel
			this.AddItem(210, 110, 2426); //PetrifiedWood
			this.AddItem(210, 130, 3553); //Kindling
			this.AddItem(210, 150, 3969); //Compost
			this.AddItem(210, 170, 3702); //Bag
			//--<<Reagent Art>>------------------[End]
			
			//--<<Amount Of Reagents In Book>>------------------[Start]
			this.AddLabel(250, 10, 900, 	String.Format( "{0}", m_RegBook.m_DaemonBlood ) );
			this.AddLabel(250, 30, 900, 	String.Format( "{0}", m_RegBook.m_BatWing ) );
			this.AddLabel(250, 50, 900, 	String.Format( "{0}", m_RegBook.m_PigIron ) );
			this.AddLabel(250, 70, 900, 	String.Format( "{0}", m_RegBook.m_SpringWater ) );
			this.AddLabel(250, 90, 900, 	String.Format( "{0}", m_RegBook.m_DestroyingAngel ) );
			this.AddLabel(250, 110, 900, 	String.Format( "{0}", m_RegBook.m_PetrifiedWood ) );
			this.AddLabel(250, 130, 900, 	String.Format( "{0}", m_RegBook.m_Kindling ) );
			this.AddLabel(250, 150, 900, 	String.Format( "{0}", m_RegBook.m_Compost ) );
			this.AddLabel(250, 170, 900, 	String.Format( "{0}", m_RegBook.m_EmptyBags ) );
			this.AddLabel(225, 185, 32, 	@"Quick  50 [Mage]");
			this.AddLabel(225, 200, 66, 	@"Quick  50 [Necro]");
			//--<<Amount Of Reagents In Book>>------------------[End]

			//--<<Amount Of Reagents In Book>>------------------[End]
			
			//--<<Buttons>>------------------[Start]
			this.AddButton(180, 10, 2087, 2087, 	(int)Buttons.SelectNightShade, 		GumpButtonType.Reply, 0);
			this.AddButton(180, 30, 2087, 2087, 	(int)Buttons.SelectBlackPearl, 		GumpButtonType.Reply, 0);
			this.AddButton(180, 50, 2087, 2087, 	(int)Buttons.SelectBloodMoss, 		GumpButtonType.Reply, 0);
			this.AddButton(180, 70, 2087, 2087, 	(int)Buttons.SelectGarlic, 			GumpButtonType.Reply, 0);
			this.AddButton(180, 90, 2087, 2087, 	(int)Buttons.SelectGinsing, 		GumpButtonType.Reply, 0);
			this.AddButton(180, 110, 2087, 2087, 	(int)Buttons.SelectMandrake, 		GumpButtonType.Reply, 0);
			this.AddButton(180, 130, 2087, 2087, 	(int)Buttons.SelectSulfurousAsh, 	GumpButtonType.Reply, 0);
			this.AddButton(180, 150, 2087, 2087, 	(int)Buttons.SelectSpidersSilk, 	GumpButtonType.Reply, 0);
			this.AddButton(180, 170, 2087, 2087, 	(int)Buttons.SelectNoxCrystal, 		GumpButtonType.Reply, 0);
			this.AddButton(180, 190, 2087, 2087, 	(int)Buttons.SelectGraveDust, 		GumpButtonType.Reply, 0);
			this.AddButton(370, 10, 2087, 2087, 	(int)Buttons.SelectDaemonBlood, 	GumpButtonType.Reply, 0);
			this.AddButton(370, 30, 2087, 2087, 	(int)Buttons.SelectBatWings, 		GumpButtonType.Reply, 0);
			this.AddButton(370, 50, 2087, 2087, 	(int)Buttons.SelectPigIron, 		GumpButtonType.Reply, 0);
			this.AddButton(370, 70, 2087, 2087, 	(int)Buttons.SelectSpringWater, 	GumpButtonType.Reply, 0);
			this.AddButton(370, 90, 2087, 2087, 	(int)Buttons.SelectDestroyingAngel, GumpButtonType.Reply, 0);
			this.AddButton(370, 110, 2087, 2087, 	(int)Buttons.SelectPetrifiedWood, 	GumpButtonType.Reply, 0);
			this.AddButton(370, 130, 2087, 2087, 	(int)Buttons.SelectKindling, 		GumpButtonType.Reply, 0);
			this.AddButton(370, 150, 2087, 2087, 	(int)Buttons.SelectCompost, 		GumpButtonType.Reply, 0);
			this.AddButton(370, 170, 2087, 2087, 	(int)Buttons.SelectEmptyBag, 		GumpButtonType.Reply, 0);
			this.AddButton(370, 185, 2087, 2087, 	(int)Buttons.SelectQuick50Mage, 	GumpButtonType.Reply, 0);
			this.AddButton(370, 200, 2087, 2087, 	(int)Buttons.SelectQuick50Necro, 	GumpButtonType.Reply, 0);
			//--<<Buttons>>------------------[End]
		}
		
		public enum Buttons
		{
			SelectNightShade=1,
			SelectBlackPearl,
			SelectBloodMoss,
			SelectGarlic,
			SelectGinsing,
			SelectMandrake,
			SelectSulfurousAsh,
			SelectSpidersSilk,
			SelectNoxCrystal,
			SelectGraveDust,
			SelectDaemonBlood,
			SelectBatWings,
			SelectPigIron,
			//--<<AS Edit>>------------------[Start]
			SelectSpringWater,
			SelectDestroyingAngel,
			SelectPetrifiedWood,
			SelectKindling,
			SelectCompost,
			//--<<AS Edit>>------------------[End]
			SelectEmptyBag,
			SelectQuick50Mage,
			SelectQuick50Necro,
		}
		
		public override void OnResponse( NetState state, RelayInfo info )
		{
			Mobile from = state.Mobile;
			
			switch( ( Buttons )info.ButtonID )
			{
				case Buttons.SelectNightShade:
					{
						from.SendMessage(0x55C,"How many Nightshade do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectBlackPearl:
					{
						from.SendMessage(0x55C,"How many Black Pearl do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectBloodMoss:
					{
						from.SendMessage(0x55C,"How many Bloodmoss do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectGarlic:
					{
						from.SendMessage(0x55C,"How many Garlic do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectGinsing:
					{
						from.SendMessage(0x55C,"How many Ginseng do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectMandrake:
					{
						from.SendMessage(0x55C,"How many Mandrake Root do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectSulfurousAsh:
					{
						from.SendMessage(0x55C,"How many Sulfurous Ash do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectSpidersSilk:
					{
						from.SendMessage(0x55C,"How many Spiders Silk do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectNoxCrystal:
					{
						from.SendMessage(0x55C,"How many Nox Crystal do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}break;
				case Buttons.SelectGraveDust:
					{
						from.SendMessage(0x55C,"How many Grave Dust do you want to take out?");
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectDaemonBlood:
					{
						from.SendMessage(0x55C,"How many Daemon Blood do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectBatWings:
					{
						from.SendMessage(0x55C,"How many Bat Wing do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
				case Buttons.SelectPigIron:
					{
						from.SendMessage(0x55C,"How many Pig Iron do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, (int)info.ButtonID );
					}
					break;
					
				case Buttons.SelectSpringWater:
					{
						from.SendMessage( 0x55C, "How many Spring Water do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, ( int )info.ButtonID );
					}
					break;
				case Buttons.SelectDestroyingAngel:
					{
						from.SendMessage( 0x55C, "How many Destroying Angel do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, ( int )info.ButtonID );
					}
					break;
				case Buttons.SelectPetrifiedWood:
					{
						from.SendMessage( 0x55C, "How many Petrified Wood do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, ( int )info.ButtonID );
					}
					break;
				case Buttons.SelectKindling:
					{
						from.SendMessage( 0x55C, "How many Kindling do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, ( int )info.ButtonID );
					}
					break;
				case Buttons.SelectCompost:
					{
						from.SendMessage( 0x55C, "How many Compost do you want to take out?" );
						from.Prompt = new RegRemovalPrompt( from, m_RegBook, ( int )info.ButtonID );
					}
					break;
					
				case Buttons.SelectEmptyBag:
					{
						if( m_RegBook.m_EmptyBags <= 0 )
						{
							from.SendMessage( 0x26, "You dont have any bags to take out.." );
						}
						else
						{
							m_RegBook.m_EmptyBags -= 1;
							from.AddToBackpack( new Bag() );
							from.SendMessage( 0x55C, "You take out a empty bag." );
						}
					}
					break;
				case Buttons.SelectQuick50Mage:
					{
						if( m_RegBook.m_EmptyBags <= 0 )
						{
							from.SendMessage( 0x26, "You need empty bags to use this option" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from,m_RegBook ) );
							
						}
						else if(
						        m_RegBook.m_BlackPearl		<=49 ||
						        m_RegBook.m_BloodMoss		<=49 ||
						        m_RegBook.m_Garlic			<=49 ||
						        m_RegBook.m_Ginseng			<=49 ||
						        m_RegBook.m_SulfurousAsh	<=49 ||
						        m_RegBook.m_SpidersSilk		<=49 ||
						        m_RegBook.m_NightShade		<=49 ||
						        m_RegBook.m_MandrakeRoot	<=49
						       )
						{
							from.SendMessage( 0x26, "You dont have enough of some regs to get a quick 50." );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from,m_RegBook ) );
						}
						else if( from.PlaceInBackpack( new BagOfReagents() ) )
						{
							m_RegBook.m_BlackPearl		-= 50;
							m_RegBook.m_BloodMoss		-= 50;
							m_RegBook.m_Garlic			-= 50;
							m_RegBook.m_Ginseng			-= 50;
							m_RegBook.m_SulfurousAsh	-= 50;
							m_RegBook.m_SpidersSilk		-= 50;
							m_RegBook.m_NightShade		-= 50;
							m_RegBook.m_MandrakeRoot	-= 50;
							m_RegBook.m_EmptyBags		-= 1;
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from,m_RegBook ) );
						}
						else
						{
							from.SendMessage( 0x26, "you don't have enough room in your backpack to hold this." );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from, m_RegBook ) );
						}
						
					}break;
				case Buttons.SelectQuick50Necro:
					{
						if( m_RegBook.m_EmptyBags <= 0 )
						{
							from.SendMessage( 0x26, "You need empty bags to use this option" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from, m_RegBook ) );
							
						}
						else if(
						        m_RegBook.m_NoxCrystal		<=49 ||
						        m_RegBook.m_DaemonBlood		<=49 ||
						        m_RegBook.m_BatWing			<=49 ||
						        m_RegBook.m_PigIron			<=49 ||
						        m_RegBook.m_GraveDust	    <=49 )
						{
							from.SendMessage(0x26,"You dont have enough of some regs to get a quick 50." );
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(from,m_RegBook));
						}
						else if( from.PlaceInBackpack( new BagOfNecroReagents() ) )
						{
							m_RegBook.m_NoxCrystal		-= 50;
							m_RegBook.m_DaemonBlood		-= 50;
							m_RegBook.m_BatWing			-= 50;
							m_RegBook.m_PigIron			-= 50;
							m_RegBook.m_GraveDust   	-= 50;
							m_RegBook.m_EmptyBags		-= 1;
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from, m_RegBook ) );
						}
						else
						{
							from.SendMessage( 0x26, "you don't have enough room in your backpack to hold this." );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( from, m_RegBook ) );
						}
					}
					break;
				default:
					{
						//Nothing
					}
					break;
			}
		}
		
		
		public class RegRemovalPrompt : Prompt
		{
			private Mobile m_Player;
			private RegBook m_RegBook;
			private int m_Buttons;
			
			public RegRemovalPrompt( Mobile player, RegBook regbook, int button )
			{
				m_Player = player;
				m_RegBook = regbook;
				m_Buttons = button;
			}
			
			public override void OnResponse( Mobile from, string text )
			{
				// Magery Reg Prompt Info
				#region NightShade Selection
				if(m_Buttons == (int)Buttons.SelectNightShade)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_NightShade - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Nightshade left.");
							}
							else
							{
								if( from.PlaceInBackpack( new Nightshade(amount) ))
								{
									m_RegBook.m_NightShade -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Nightshade to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region BlackPearl Selection
				if(m_Buttons == (int)Buttons.SelectBlackPearl)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_BlackPearl - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Black Pearl left.");
							}
							else
							{
								if( from.PlaceInBackpack( new BlackPearl(amount) ))
								{
									m_RegBook.m_BlackPearl -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Black Pearl to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Bloodmoss Selection
				if(m_Buttons == (int)Buttons.SelectBloodMoss)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_BloodMoss - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Bloodmoss left.");
							}
							else
							{
								if( from.PlaceInBackpack( new Bloodmoss(amount) ))
								{
									m_RegBook.m_BloodMoss -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Bloodmoss to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Garlic Selection
				if(m_Buttons == (int)Buttons.SelectGarlic)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_Garlic - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Garlic left.");
							}
							else
							{
								if( from.PlaceInBackpack( new Garlic(amount) ))
								{
									m_RegBook.m_Garlic -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Garlic to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Ginseng Selection
				if(m_Buttons == (int)Buttons.SelectGinsing)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_Ginseng - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Ginseng left.");
							}
							else
							{
								if( from.PlaceInBackpack( new Ginseng(amount) ))
								{
									m_RegBook.m_Ginseng -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Ginseng to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Mandrake Root Selection
				if(m_Buttons == (int)Buttons.SelectMandrake)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_MandrakeRoot - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Mandrake Root left.");
							}
							else
							{
								if( from.PlaceInBackpack( new MandrakeRoot(amount) ))
								{
									m_RegBook.m_MandrakeRoot -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Mandrake Root to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Sulfurous Ash Selection
				if(m_Buttons == (int)Buttons.SelectSulfurousAsh)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_SulfurousAsh - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Sulfurous Ash left.");
							}
							else
							{
								if( from.PlaceInBackpack( new SulfurousAsh(amount) ))
								{
									m_RegBook.m_SulfurousAsh -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Sulfurous Ash to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Spider's Silk Selection
				if(m_Buttons == (int)Buttons.SelectSpidersSilk)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_SpidersSilk - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Spider's Silk left.");
							}
							else
							{
								if( from.PlaceInBackpack( new SpidersSilk(amount) ))
								{
									m_RegBook.m_SpidersSilk -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} SpidersSilk to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				
				// Necromancy Reg Prompt Info
				#region Nox Crystal Selection
				if(m_Buttons == (int)Buttons.SelectNoxCrystal)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_NoxCrystal - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Nox Crystal left.");
							}
							else
							{
								if( from.PlaceInBackpack( new NoxCrystal(amount) ))
								{
									m_RegBook.m_NoxCrystal -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Nox Crystal to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Grave Dust Selection
				if(m_Buttons == (int)Buttons.SelectGraveDust)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_GraveDust - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Grave Dust left.");
							}
							else
							{
								if( from.PlaceInBackpack( new GraveDust(amount) ))
								{
									m_RegBook.m_GraveDust -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Grave Dust to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region DaemonBlood Selection
				if(m_Buttons == (int)Buttons.SelectDaemonBlood)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_DaemonBlood - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Daemon Blood left.");
							}
							else
							{
								if( from.PlaceInBackpack( new GraveDust(amount) ))
								{
									m_RegBook.m_DaemonBlood -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Daemon Blood to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Bat Wing Selection
				if(m_Buttons == (int)Buttons.SelectBatWings)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_BatWing - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Bat Wing left.");
							}
							else
							{
								if( from.PlaceInBackpack( new BatWing(amount) ))
								{
									m_RegBook.m_BatWing -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Bat Wing to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Pig Iron Selection
				if(m_Buttons == (int)Buttons.SelectPigIron)
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if(amount != 0 )
						{
							if((m_RegBook.m_PigIron - amount) < 0)
							{
								from.SendMessage(0x26,"You dont have that many Pig Iron left.");
							}
							else
							{
								if( from.PlaceInBackpack( new PigIron(amount) ))
								{
									m_RegBook.m_PigIron -= amount;
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
									from.SendMessage(0x55C,String.Format("You have remove {0} Pig Iron to your Reg Book.",amount));
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump(typeof(RegBookGump));
									from.SendGump(new RegBookGump(m_Player,m_RegBook));
								}
								
							}
						}
						else
						{
							from.SendMessage(0x26,"You cannot withdraw 0 reagents");
							from.CloseGump(typeof(RegBookGump));
							from.SendGump(new RegBookGump(m_Player,m_RegBook));
						}
					}
					catch
					{
						from.SendMessage(0x26,"Invalid Entry");
						from.CloseGump(typeof(RegBookGump));
						from.SendGump(new RegBookGump(m_Player,m_RegBook));
					}
				}
				#endregion
				#region Spring Water Selection
				if( m_Buttons == ( int )Buttons.SelectSpringWater )
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if( amount != 0 )
						{
							if( ( m_RegBook.m_SpringWater - amount ) < 0 )
							{
								from.SendMessage( 0x26, "You dont have that many Spring Water left." );
							}
							else
							{
								if( from.PlaceInBackpack( new SpringWater( amount ) ) )
								{
									m_RegBook.m_SpringWater -= amount;
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
									from.SendMessage( 0x55C, String.Format( "You have remove {0} Spring Water to your Reg Book.", amount ) );
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
								}
							}
						}
						else
						{
							from.SendMessage( 0x26, "You cannot withdraw 0 reagents" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
						}
					}
					catch
					{
						from.SendMessage( 0x26, "Invalid Entry" );
						from.CloseGump( typeof( RegBookGump ) );
						from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
					}
				}
				#endregion
				#region Destroying Angel Selection
				if( m_Buttons == ( int )Buttons.SelectDestroyingAngel )
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if( amount != 0 )
						{
							if( ( m_RegBook.m_DestroyingAngel - amount ) < 0 )
							{
								from.SendMessage( 0x26, "You dont have that many Destroying Angel left." );
							}
							else
							{
								if( from.PlaceInBackpack( new DestroyingAngel( amount ) ) )
								{
									m_RegBook.m_DestroyingAngel -= amount;
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
									from.SendMessage( 0x55C, String.Format( "You have remove {0} Destroying Angel to your Reg Book.", amount ) );
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
								}
							}
						}
						else
						{
							from.SendMessage( 0x26, "You cannot withdraw 0 reagents" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
						}
					}
					catch
					{
						from.SendMessage( 0x26, "Invalid Entry" );
						from.CloseGump( typeof( RegBookGump ) );
						from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
					}
				}
				#endregion
				#region Petrified Wood Selection
				if( m_Buttons == ( int )Buttons.SelectPetrifiedWood )
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if( amount != 0 )
						{
							if( ( m_RegBook.m_PetrifiedWood - amount ) < 0 )
							{
								from.SendMessage( 0x26, "You dont have that many Petrified Wood left." );
							}
							else
							{
								if( from.PlaceInBackpack( new PetrifiedWood( amount ) ) )
								{
									m_RegBook.m_PetrifiedWood -= amount;
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
									from.SendMessage( 0x55C, String.Format( "You have remove {0} Petrified Wood to your Reg Book.", amount ) );
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
								}
							}
						}
						else
						{
							from.SendMessage( 0x26, "You cannot withdraw 0 reagents" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
						}
					}
					catch
					{
						from.SendMessage( 0x26, "Invalid Entry" );
						from.CloseGump( typeof( RegBookGump ) );
						from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
					}
				}
				#endregion
				#region Kindling Selection
				if( m_Buttons == ( int )Buttons.SelectKindling )
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if( amount != 0 )
						{
							if( ( m_RegBook.m_Kindling - amount ) < 0 )
							{
								from.SendMessage( 0x26, "You dont have that many Kindling left." );
							}
							else
							{
								if( from.PlaceInBackpack( new Kindling( amount ) ) )
								{
									m_RegBook.m_Kindling -= amount;
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
									from.SendMessage( 0x55C, String.Format( "You have remove {0} Kindling to your Reg Book.", amount ) );
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
								}
							}
						}
						else
						{
							from.SendMessage( 0x26, "You cannot withdraw 0 reagents" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
						}
					}
					catch
					{
						from.SendMessage( 0x26, "Invalid Entry" );
						from.CloseGump( typeof( RegBookGump ) );
						from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
					}
				}
				#endregion
				#region Compost Selection
				if( m_Buttons == ( int )Buttons.SelectCompost )
				{
					try
					{
						int amount = Convert.ToInt32( text );
						if( amount != 0 )
						{
							if( ( m_RegBook.m_Compost - amount ) < 0 )
							{
								from.SendMessage( 0x26, "You dont have that many Compost left." );
							}
							else
							{
								if( from.PlaceInBackpack( new Compost( amount ) ) )
								{
									m_RegBook.m_Compost -= amount;
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
									from.SendMessage( 0x55C, String.Format( "You have remove {0} Compost to your Reg Book.", amount ) );
								}
								else
								{
									from.SendLocalizedMessage( 1046260 ); // You need to clear some space in your inventory to continue with the quest.  Come back here when you have more space in your inventory.
									from.CloseGump( typeof( RegBookGump ) );
									from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
								}
							}
						}
						else
						{
							from.SendMessage( 0x26, "You cannot withdraw 0 reagents" );
							from.CloseGump( typeof( RegBookGump ) );
							from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
						}
					}
					catch
					{
						from.SendMessage( 0x26, "Invalid Entry" );
						from.CloseGump( typeof( RegBookGump ) );
						from.SendGump( new RegBookGump( m_Player, m_RegBook ) );
					}
				}
				#endregion
			}
		}
	}
}
