/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
All Spells Optional Restrictive System created by Alien, Daat99 and Lucid Nagual.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~     Version [5].0 & Above   _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using Server;
using Server.Network;
using Server.Items;

namespace Server.Spells.Song
{
   public abstract class Song : Spell
   {
	  public abstract double CastDelay{ get; }
      public abstract double RequiredSkill{ get; }
      public abstract int RequiredMana{ get; }

      public override SkillName CastSkill{ get{ return SkillName.Musicianship; } }
      public override SkillName DamageSkill{ get{ return SkillName.Musicianship; } }

      public override bool ClearHandsOnCast{ get{ return false; } }

      public Song( Mobile caster, Item scroll, SpellInfo info ) : base( caster, scroll, info )
      {
      }

      public override void GetCastSkills( out double min, out double max )
      {
         min = RequiredSkill;
         max = RequiredSkill + 30.0;
      }

      public override int GetMana()
      {
         return RequiredMana;
      }

	public override bool CheckCast()
	  {
		Container pack = Caster.Backpack;

		BaseInstrument ints = (BaseInstrument)pack.FindItemByType( typeof( BaseInstrument ) );

		if ( ints == null )
			{
			Caster.SendMessage("Need instrument in pack to play this.");
			return false;
			}

		if ( ints.UsesRemaining >= 2 )
			ints.UsesRemaining -= 1;

		if ( ints.UsesRemaining == 1 )
				ints.Delete();

        Caster.PlaySound( ints.SuccessSound );
		return true;
	 }

      public override TimeSpan GetCastDelay()
      {
         return TimeSpan.FromSeconds( CastDelay );
      }
   }
}