using System;
using Server.Network;
using Server.Spells;


namespace Server.Items
{
	public class BookOfFarming : Spellbook
	{
		public override SpellbookType SpellbookType{ get{ return SpellbookType.Farming; } }
		public override int BookOffset{ get{ return 1000; } }
		public override int BookCount{ get{ return 21; } }

		[Constructable]
		//public BookOfFarming() : this( ( ulong )0x3F )
		public BookOfFarming() : this( ( ulong )0 )
		{
		}

		[Constructable]
		//public BookOfFarming( ulong content ) : base( content, 0x238C )
		public BookOfFarming( ulong content ) : base( content, 7712 )
		{
			Name = "Great Book Of Harvesting";
			Hue = 53;
			Layer = (Core.ML ? Layer.OneHanded : Layer.Invalid);
		}

		
		public override void OnDoubleClick( Mobile from )
		{
			if ( from.AccessLevel == AccessLevel.Player )
			{
				Container pack = from.Backpack;
				if( !(Parent == from || (pack != null && Parent == pack)) )
				{
					from.SendMessage( "The book must be in your backpack [and not within in a container] to open." );
					return;
				}
				else if( UseRestrictions && !SpellRestrictions.CheckRestrictions( from, this ) )
				{
					return;
				}
			}
			
			from.CloseGump( typeof( BookOfFarmingGump ) );
			from.SendGump( new BookOfFarmingGump( from, this ) );
		}

		public BookOfFarming( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 1 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();

			if( version == 0 && Core.ML )
				Layer = Layer.OneHanded;
		}
	}
}