/*
Special thanks to Ryan.
With RunUO we now have the ability to become our own Richard Garriott.
All Spells System created by x-SirSly-x, Admin of Land of Obsidian.
All Spells System 4.0 created & supported by Lucid Nagual, Admin of The Conjuring.
All Spells System 5.0 created by A_li_N.
All Spells Optional Restrictive System created by Alien, Daat99 and Lucid Nagual.
    _________________________________
 -=(_)_______________________________)=-
   /   .   .   . ____  . ___      _/
  /~ /    /   / /     / /   )2005 /
 (~ (____(___/ (____ / /___/     (
  \ ----------------------------- \
   \     lucidnagual@gmail.com     \
    \_     ===================      \
     \   -Admin of "The Conjuring"-  \
      \_     ===================     ~\
       )       All Spells System       )
      /~     Version [5].0 & Above   _/
    _/_______________________________/
 -=(_)_______________________________)=-
 */
using System;
using Server;
using Server.Spells;


namespace Server.Spells.Undead
{
	public class UndeadInitializer
	{
		public static void Initialize()
		{
			if( Core.AOS )
			{
				Register( 131, typeof( UndeadPoisonMarkSpell ) );
				Register( 132, typeof( UndeadTravelByPoisonSpell ) );
				Register( 133, typeof( UndeadCurePoisonSpell ) );
				Register( 134, typeof( UndeadPoisonFieldSpell ) );
				Register( 135, typeof( UndeadGraveyardGatewaySpell ) );
				Register( 136, typeof( UndeadRevivalBySeanceSpell ) );
				Register( 137, typeof( UndeadHordeMinionsEyesSpell ) );
				Register( 138, typeof( UndeadWallOfSpikesSpell ) );
				Register( 139, typeof( UndeadPoisonIvyPatchSpell ) );
				Register( 140, typeof( UndeadBloodPactSpell ) );
				Register( 141, typeof( UndeadPoisonSpell ) );
				Register( 142, typeof( UndeadMassCurseSpell ) );
				Register( 143, typeof( UndeadMisfitsOfMondainSpell ) );

				//RegDef( spellID, "Name", "Description", "Reagent1; Reagent2; Reagentn", "Skill; Mana; Tithe; Etc" );
				RegDef( 131, "Poison Mark",         "The Necromancer uses this spell to mark runes for travel.", "Daemon Blood; Pig Iron", "Skill: 60; Mana: 30" );
				RegDef( 132, "Travel By Poison",    "The Necromancer uses this spell to travel with the use of a marked rune.", "Bat Wing; Nox Crystal", "Skill: 40; Mana: 11" );
				RegDef( 133, "Cure Poison",         "Cures most poisons on anyone targeted by this spell.", "Nox Crystal; Pig Iron", "Skill: 15; Mana: 20" );
				RegDef( 134, "Poison Field",        "Produces a wall of poison that will poison just about anything that walks through it.", "Bat Wing; Nox Crystal; Pig Iron", "Skill: 45; Mana: 20" );
				RegDef( 135, "Graveyard Gateway",   "Produces a moongate from the use of a marked rune used for travel.", "Daemon Blood; Bat Wing; Grave Dust", "Skill: 70; Mana: 45" );
				RegDef( 136, "Revival By Seance",   "Resurrects person of choice by the use of a Ouija board.", "Nox Crystal; Daemon Blood; Grave Dust", "Skill: 90; Mana: 55" );
				RegDef( 137, "Horde Minion's Eyes", "Grants the target the eyes of a horde minion for superior vision to see at night.", "Bat Wing; Nox Crystal", "Skill: 15; Mana: 5" );
				RegDef( 138, "Wall Of Spikes",      "Summons a wall of stone spikes as a shield.", "Daemon Blood; Pig Iron", "Skill: 24; Mana: 10" );
				RegDef( 139, "Poison Ivy Patch",    "Forms a circle of poison ivy that causes damage & the ability to poison when walked on.", "Grave Dust; Nox Crystal; Pig Iron", "Skill: 68; Mana: 28" );
				RegDef( 140, "Blood Pact",          "Heals a person of choice draining health & blood from the Necromancer.", "Bat Wing; Pig Iron", "Skill: 33; Mana: 15" );
				RegDef( 141, "Poison",              "Poison's the slected target.", "Nox Crystal; Daemon Blood", "Skill: 30; Mana: 20" );
				RegDef( 142, "Mass Curse",          "Lowers the nearby enemeies abilities in combat.", "Bat Wing; Grave Dust; Daemon Blood; Nox Crystal", "Skill: 65; Mana: 25" );
				RegDef( 143, "Misfits Of Mondain",  "Summons creatures of the undead to aid in battle.", "Bat Wing; Grave Dust; Nox Crystal", "Skill: 37; Mana: 30" );
			}
		}
		
		public static void Register( int spellID, Type type )
		{
			SpellRegistry.Register( spellID, type );
		}
		
		public static void RegDef( int spellID, string name, string des, string regs, string inf )
		{
			SpellDefRegistry.Register( spellID, name, des, regs, inf );
		}
	}
}
